<x:stylesheet version='1.0' xmlns:x="http://www.w3.org/1999/XSL/Transform">
<x:output method='text'/>

<x:template match="parser">
/* This code is generated. Change template, not this */
#ifndef __HEADER_<x:value-of select="@name"/>
#define __HEADER_<x:value-of select="@name"/>

#include "mpsys.h"

#define DVB_MAX_SECTION_LENGTH 4096 /* EIT, otherwise 1024 */
<x:apply-templates/>

#endif
</x:template>

<x:template match="group">
<x:apply-templates/>

int <x:value-of select="@name"/>_parsable (buffer *);
void <x:value-of select="@name"/>_parse_and_print (buffer *, FILE *);
void <x:value-of select="@name"/>_loop_and_print (buffer_iter *, FILE *);
</x:template>

<x:template match="struct">
typedef struct <x:value-of select="@name"/>_st {
	<x:apply-templates/>
} <x:value-of select="@name"/>;

int <x:value-of select="@name"/>_parsable (buffer *);
char * <x:value-of select="@name"/>_parsable_error (buffer *);
void <x:value-of select="@name"/>_skip (buffer_iter *);
void <x:value-of select="@name"/>_parse (<x:value-of select="@name"/> *, buffer *);
void <x:value-of select="@name"/>_print (<x:value-of select="@name"/> *, FILE *);
void <x:value-of select="@name"/>_parse_and_print (buffer *, FILE *);

</x:template>

<x:template match="constant|filler"/>

<x:template match="int|isolang|bcd">int <x:value-of select="@name"/>;</x:template>

<x:template match="lenstr">buffer_iter <x:value-of select="@name"/>;</x:template>

<x:template match="data">buffer_iter <x:value-of select="@name"/>;</x:template>

<x:template match="repeat">
int <x:value-of select="@name"/>_count;
struct <x:value-of select="ancestor::struct/@name"/>_<x:value-of select="@name"/>_st 
{
	<x:apply-templates/>
<!-- try to compute max number of items, from minium estimation of content size (in packet) -->
} <x:value-of select="@name"/>[DVB_MAX_SECTION_LENGTH/<x:value-of select="(sum (*/@bits) div 8)+count(lenstr)+count (isolang)*3"/>];

</x:template>
</x:stylesheet>
